<?php
/**
 * @package Sj Zoo Categories
 * @version 2.5
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 * 
 */
defined('_JEXEC') or die;

if (!class_exists('ZooCategoriesReader')){
	class ZooCategoriesReader extends SjReader{
		public function getList(&$params){
			 $list = array();	
			 $category_ids = $this->zoo->getPublishedCategories($params);			
			 if(!empty($category_ids)){
				 foreach($category_ids as $cid){
					$category = $this->zoo->getCategory($cid);					
					$category->link = JRoute::_('index.php?option=com_zoo&task=category&category_id='.$cid);
					 if (!isset($category->image_extracted)){
								$category_images = YTools::extractImages($category->description);
								$category->image_extracted = true;
					 }							
					 if (!isset($category->image) && count($category_images)){					
						 foreach ($category_images as $i => $image_url) {
							if (YTools::isUrl($image_url) || file_exists($image_url)){
								$category->image = $image_url;
								break;
								}
							}
						}
					 if (!isset($category->image) || (!YTools::isUrl($category->image) && !file_exists($category->image))){
						 $category->image = 'modules/'.Ytools::getModule()->module . '/assets/images/nophoto.gif';
					  }					  
					 if(count($category->child_category)>=$params['sub_cat_limit']){
						$category->child_category=array_slice($category->child_category,0,$params['sub_cat_limit']);
						}else{
						$category->child_category=$category->child_category;
					 }
						  foreach($category->child_category as $key_cat=> $cat_child){																				
							$cat_child->link = JRoute::_('index.php?option=com_zoo&task=category&category_id='.$cat_child->id);							
							if (!isset($cat_child->image_extracted)){
								$cat_child_images = YTools::extractImages($cat_child->description);
								$cat_child->image_extracted = true;
								}							
							if (!isset($cat_child->image)){
								// get first exists image
								foreach ($cat_child_images as $i => $cat_child_url) {
									if (YTools::isUrl($cat_child_url) || file_exists($cat_child_url)){
										$cat_child->image = $cat_child_url;
										break;
									}
								}
							}
							// final check image exists
							if (!isset($cat_child->image) || (!YTools::isUrl($cat_child->image) && !file_exists($cat_child->image))){
								$cat_child->image = 'modules/'.Ytools::getModule()->module . '/assets/images/nophoto.gif';
							}
							
					$cat_child->new_count=count($this->zoo->getCategoryItems($cat_child->id,$params,true));		
						}
						
   					
				$list[$cid]=$category;					
				}
			}			

			return $list;
		}					
	}
}